// Copyright 1998-1999 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.

#import "OAIObjCTokenizer.h"

extern "C" {
    #import <OmniBase/rcsid.h>
};

RCS_ID("$Header: /Network/Source/CVS/OmniGroup/OmniAIAT/OAIObjCTokenizer.M,v 1.7 1999/06/02 06:19:23 bungi Exp $")

OAIObjCTokenizer::OAIObjCTokenizer(id <OAITokenizerInstance> objCObject)
{
    tokenizer = [objCObject retain];
    tokenArray = [[NSMutableArray alloc] init];
}

OAIObjCTokenizer::~OAIObjCTokenizer()
{
    [tokenizer release];
    [tokenArray release];
}

IAToken *OAIObjCTokenizer::GetNextToken()
{
    NSString *string;

#warning TJW -- Luke says that this is hacked up since it is not even used by the stuff Greg wrote anyway.
    static unsigned int index = 0;

    string = [tokenizer nextToken];
    if (string) {
        IAToken      *token;

        // -cString uses NSMacOSRomanStringEncoding these days
        if ([string canBeConvertedToEncoding: NSMacOSRomanStringEncoding]) {
            unsigned int  stringLength;

            stringLength = [string cStringLength];
            token = new IAToken(new StringTerm([string cString]), index, index + stringLength);
            index += stringLength + 1;
        } else {
#warning TJW -- And this would probably break since the index is supposed to be the byte index in the source.
            // Also, this won't really allow Unicode strings to be indexed (presumably) since
            // they'll have stuff like '\U123' in the middle of them.
            NSData       *data;
            unsigned int  length;
            
            data = [string dataUsingEncoding: NSNonLossyASCIIStringEncoding];
            length = [data length];
            token = new IAToken(new StringTerm((const char *)[data bytes]), index, index + length);
            index += length + 1;
        }

        [tokenArray addObject:string];

        return token;
    }
    return NULL;
}

void OAIObjCTokenizer::GetTextSpan(byte *dest, uint32 startPos, uint32 endPos)
{
    NSString *string;

    string = [tokenArray objectAtIndex:startPos];
    [string getCString:(char *)dest];
}

